using GTA;
using GTA.Native;
using System;
using System.Diagnostics;
using System.Drawing;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Runtime.Versioning;
using System.Windows.Forms;

namespace Restaurant
{
	public class cs : Script
	{
		private Keys toggleMenuKey;
		private Keys selectionKey;
		private Keys menuUpKey;
		private Keys menuDownKey;
		private bool isMenuOn;
		private bool menuReady;
		private int menuSelection;
		private float x;
		private float y;
		private float spacing;
		private Vector3[] positions;
		private bool Restaurant()
		{
			Vector3[] array = this.positions;
			for (int i = 0; i < array.Length; i++)
			{
				Vector3 position = array[i];
				if (base.Player.Character.Position.DistanceTo(position) < 2f)
				{
					return true;
				}
			}
			return false;
		}
		
		public cs()
		{
			this.positions = new Vector3[]
			{
				// to add your own restaurant add a Vector3 line with your restaurant coordinates below . Don't forget the f and the lack of comma at last line
				//Ile est
				new Vector3(888.35f, -499.23f, 19.42f),
				new Vector3(938.09f, -579.27f, 14.21f),
				new Vector3(945.85f, -584.41f, 14.23f),
				new Vector3(924.68f, 10.76f, 27.63f),
				new Vector3(899.59f, 45.41f, 27.44f),
				new Vector3(928.90f, 292.67f, 27.11f),
				new Vector3(946.91f, 444.53f, 16.04f),
				new Vector3(1228.39f, 751.63f, 36.12f),
				// Ile centrale
				new Vector3(94.00f, 856.40f, 45.05f),
				new Vector3(114.19f, 641.03f, 14.72f),
				new Vector3(109.54f, 631.88f, 14.72f),
				new Vector3(-131.45f, 1408.23f, 20.42f),
				new Vector3(-420.14f, 1469.09f, 38.97f),
				new Vector3(150.69f, -475.76f, 14.77f),
				new Vector3(151.79f, -516.06f, 14.78f),
				new Vector3(51.09f, 473.64f, 14.70f),
				new Vector3(70.35f, -397.09f, 14.77f),
				new Vector3(-73.30f, -94.76f, 14.77f),
				new Vector3(-73.88f, -73.96f, 14.77f),
				new Vector3(374.55f, -524.30f, 5.82f),
				new Vector3(453.92f, -488.88f, 5.82f),
				new Vector3(-110.07f, -899.17f, 5.12f),
				new Vector3(-110.20f, -1030.38f, 5.12f),
				new Vector3(212.79f, -261.82f, 9.08f),
				new Vector3(-389.22f, 244.08f, 15.35f),
				new Vector3(-381.21f, 240.42f, 15.35f),
				new Vector3(-273.69f, 1477.76f, 20.44f),
				// Ile ouest
				new Vector3(-1017.09f, 1268.32f, 26.45f),
				new Vector3(-1160.05f, 1400.85f, 24.40f),
				new Vector3(-1254.87f, 1316.09f, 21.78f),
				new Vector3(-1243.18f, 1071.34f, 19.79f),
				new Vector3(-1565.68f, 585.31f, 25.45f),
				new Vector3(-1573.74f, 663.59f, 25.45f),
				new Vector3(-1519.56f, 689.18f, 25.45f),
				new Vector3(-1554.70f, 505.30f, 25.73f),
				new Vector3(-1363.99f, 526.99f, 13.56f),
				new Vector3(-1364.16f, 520.50f, 13.56f),
				new Vector3(-1481.80f, -52.98f, 7.58f),
				new Vector3(40.41f, -335.71f, 14.76f),
				new Vector3(-11.41f, -321.33f, 14.77f),
				new Vector3(-1512.93f, 1404.06f, 13.18f),
				new Vector3(-182.36f, 583.09f, 119.31f)
			};
			// Remove the // below (only below) to get restaurants locations on map
			//Vector3[] array = this.positions;
			//for (int i = 0; i < array.Length; i++)
			//{
				//Vector3 target = array[i];
				//Blip blip = Blip.AddBlip(target);
				//blip.Name = "YOU WILL NEVER SEE THIS";
				//blip.ShowOnlyWhenNear = true;
				//blip.Icon = BlipIcon.Activity_Restaurant;
				//blip.Scale = 1f;
				//blip.Display = BlipDisplay.ArrowAndMap;
			//}
			this.x = (float)Game.Resolution.Width * 0.1f;
			this.y = (float)Game.Resolution.Height * 0.1f;
			this.spacing = (float)Game.Resolution.Height / 50f;
			// replace Keys.U below by Keys.YourKey
			this.toggleMenuKey = base.Settings.GetValueKey("TOGGLE_MENU_KEY", Keys.U);
			this.selectionKey = base.Settings.GetValueKey("SELECTION_KEY", Keys.Return);
			this.menuUpKey = base.Settings.GetValueKey("MENU_UP_KEY", Keys.Up);
			this.menuDownKey = base.Settings.GetValueKey("MENU_DOWN_KEY", Keys.Down);
			base.BindKey(this.toggleMenuKey, false, false, false, new KeyPressDelegate(this.ToggleMenu));
			base.Tick += new EventHandler(this.HelpTick);
		}
		
		private void ToggleMenu()		
		{	
			if (!this.menuReady)
			{
				return;
			}
			this.isMenuOn = !this.isMenuOn;
			if (this.isMenuOn)
			{
				base.Tick -= new EventHandler(this.HelpTick);
				base.PerFrameDrawing += new GraphicsEventHandler(this.Menu_PerFrameDrawing);
				base.KeyDown += new GTA.KeyEventHandler(this.Menu_KeyDown);
				base.Player.CanControlCharacter = false;
				return;
			}
			base.Tick += new EventHandler(this.HelpTick);
			base.PerFrameDrawing -= new GraphicsEventHandler(this.Menu_PerFrameDrawing);
			base.KeyDown -= new GTA.KeyEventHandler(this.Menu_KeyDown);
			base.Player.CanControlCharacter = true;
		}
		
		private void Menu_KeyDown(object sender, GTA.KeyEventArgs e)
		{
			if (e.Key == this.menuUpKey)
			{
				this.menuSelection--;
				this.menuSelection = ((this.menuSelection < 0) ? 3 : this.menuSelection);
			}
			if (e.Key == this.menuDownKey)
			{
				this.menuSelection++;
				this.menuSelection = ((this.menuSelection > 3) ? 0 : this.menuSelection);
			}
			if (e.Key == this.selectionKey)
			{
				switch (this.menuSelection)
				{
				case 0:
					this.VingtMin();
					return;
				case 1:
					this.QuaranteMin();
					return;
				case 2:
					this.UneHeureTrente();
					return;
				case 3:
					this.DeuxHeures();
					break;
				default:
					return;
				}
			}
		}
		
		private void Menu_PerFrameDrawing(object sender, GraphicsEventArgs e)
		{
			e.Graphics.DrawText("20 minutes break (15$)", this.x, this.y, (this.menuSelection == 0) ? Color.PaleTurquoise : Color.White);
			e.Graphics.DrawText("40 minutes break (15$)", this.x, this.y + this.spacing, (this.menuSelection == 1) ? Color.PaleTurquoise : Color.White);
			e.Graphics.DrawText("1h30 break (15$)", this.x, this.y + this.spacing * 2f, (this.menuSelection == 2) ? Color.PaleTurquoise : Color.White);
			e.Graphics.DrawText("2h break (15$)", this.x, this.y + this.spacing * 3f, (this.menuSelection == 3) ? Color.PaleTurquoise : Color.White);
		}
		
		private void VingtMin()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours ,
					World.CurrentDayTime.Minutes + 20
				});
				base.Player.Character.Health += 200;
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Not enough money.");
		}
		
		private void QuaranteMin()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours ,
					World.CurrentDayTime.Minutes + 40
				});
				base.Player.Character.Health += 200;
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Not enough money.");
		}
		
		private void UneHeureTrente()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours + 1,
					World.CurrentDayTime.Minutes + 30
				});
				base.Player.Character.Health += 200;
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Not enough money.");
		}
		
				private void DeuxHeures()
		{
			if (base.Player.Money >= 15)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours + 2,
					World.CurrentDayTime.Minutes 
				});
				base.Player.Character.Health += 200;
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 15;
				return;
			}
			Game.DisplayText("Not enough money.");
		}
		
		private void HelpTick(object sender, EventArgs e)
		{
			this.menuReady = this.Restaurant();
			if (this.menuReady)
			{
				Game.DisplayText("Press U to take a break");
			}
	     }
	}
}